using System.ComponentModel;

namespace Bobasoft
{
    public class ObservableObject : INotifyPropertyChanged
    {
        //======================================================
        #region _Public properties_

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        //======================================================
        #region _Public properties_

        protected void RaisePropertyChanged(string propertyName)
        {
            var eventHandler = PropertyChanged;
            if (eventHandler != null)
                eventHandler(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion
    }
}